
function alert( msg )
{
	moi.ui.commandUI.alert( msg );
}

function EvalCycloid( t, aRadius, bRadius, length, numcycles )
{
	var phi = t * Math.PI * 2.0 * numcycles
	var x = aRadius * phi - bRadius * Math.sin( phi );
	var y = aRadius - bRadius * Math.cos( phi );
	var z = 0.0;
		
	return moi.vectorMath.createPoint( x, y, z );
}

function Update()
{
	var factory = moi.command.createFactory( 'interpcurve' );

	var aRadius = moi.ui.commandUI.aRadius.numericValue;
	var bRadius = moi.ui.commandUI.bRadius.numericValue;
	var length = moi.ui.commandUI.len.numericValue;
	var numcycles = moi.ui.commandUI.numcycles.integerValue;
	var numpoints = moi.ui.commandUI.numpoints.integerValue * numcycles;
	
	for ( var i = 0; i < numpoints; ++i )
	{
		var t = i / (numpoints - 1);
		
		var pt = EvalCycloid( t, aRadius, bRadius, length, numcycles );		
		
		factory.createInput( 'point' );
		factory.setInput( factory.numInputs - 1, pt );
	}
	
	factory.update();
	
	return factory;
}

function DoCycloid()
{
	var factory = Update();

	var dlg = moi.ui.commandDialog;
	
	while ( 1 )
	{
		if ( !dlg.waitForEvent() )
		{
			factory.cancel();
			return false;
		}
			
		if ( dlg.event == 'done' )
			break;
			
		if ( dlg.event == 'aRadius' || dlg.event == 'bRadius' ||  dlg.event == 'len' || dlg.event == 'numcycles' || dlg.event == 'numpoints' )
		{
			factory.cancel();
			factory = Update();
		}
	}
	
	factory.commit();
}

DoCycloid();
