
function alert( msg )
{
	moi.ui.commandUI.alert( msg );
}

function Cancel( factories )
{
	for ( var i = 0; i < factories.length; ++i )
		factories[i].cancel();
		
	factories.length = 0;
}

function Commit( factories )
{
	for ( var i = 0; i < factories.length; ++i )
		factories[i].commit();
}

// theta, an angle parameter, varies fractionally from 0 to 2*PI
function EvalTrefoil( t )
{
	var theta;
	theta = Math.PI * 2.0 * t;
	cosT = Math.cos(theta);
	sinT = Math.sin(theta);
	cos2T = Math.cos(2*theta);
	sin2T = Math.sin(2*theta);
	cos3T = Math.cos(3*theta);
	sin3T = Math.sin(3*theta);

	var x = 0.01 * (41 * cosT - 18 * sinT - 83 * cos2T - 83 * sin2T - 11 * cos3T + 27 * sin3T);
	var y = 0.01 * (36 * cosT + 27 * sinT - 113 * cos2T + 30 * sin2T + 11 * cos3T - 27 * sin3T);
	var z = 0.01 * (45 * sinT - 30 * cos2T + 113 * sin2T - 11 * cos3T + 27 * sin3T);

	return moi.vectorMath.createPoint( x, y, z );
}

function EvalFigure8( t )
{
	var theta;
	theta = Math.PI * 2.0 * t;
	cosT = Math.cos(theta);
	sinT = Math.sin(theta);
	cos2T = Math.cos(2*theta);
	sin2T = Math.sin(2*theta);
	cos3T = Math.cos(3*theta);
	sin3T = Math.sin(3*theta);

	var x = 0.01 * (32 * cosT - 51 * sinT - 104 * cos2T - 34 * sin2T + 104 * cos3T - 91 * sin3T);
	var y = 0.01 * (94 * cosT + 41 * sinT + 113 * cos2T - 68 * cos3T - 124 * sin3T);
	var z = 0.01 * (16 * cosT + 73 * sinT - 211 * cos2T - 39 * sin2T - 99 * cos3T - 21 * sin3T);

	return moi.vectorMath.createPoint( x, y, z );
}

function Update( numpoints, curvetype, buildtype, factories )
{
	Cancel( factories );

	if ( buildtype == 'points' )
	{
//		var pointfactory = moi.command.createFactory( 'point' );
	
		for ( var i = 0; i < numpoints; ++i )
		{
			var t = i / (numpoints - 1 );
			if (curvetype == 'EvalTrefoil')
				var pt = EvalTrefoil( t );
			else
			var pt = EvalFigure8( t );			
	
			var pointfactory = moi.command.createFactory( 'point' );
			pointfactory.setInput( 0, pt );
			factories.push( pointfactory );
		}
	}	
	
	else
	{
		var factory = moi.command.createFactory( 'curve' );	
	
		for ( var i = 0; i < numpoints; ++i )
		{
			var t = i / (numpoints - 1 );
			if (curvetype == 'EvalTrefoil')			
				var pt = EvalTrefoil( t );
			else
				var pt = EvalFigure8( t );				
			factory.createInput( 'point' );
			factory.setInput( factory.numInputs - 1, pt );
		}
		factories.push( factory );		
	}	
	
	for ( var i = 0; i < factories.length; ++i )
		factories[i].update();
}

function DoHarmonicKnot()
{
	var factories = new Array();
	var UI = moi.ui.commandUI;
	Update( UI.numpoints.integerValue, UI.SelectCurve.value, UI.Build.value, factories);

	// Wait for cancel or done.
	var dlg = moi.ui.commandDialog;

	while ( 1 )
	{
		if ( !dlg.waitForEvent() )
		{
			Cancel( factories );
			return false;
		}
			
		if ( dlg.event == 'done' )
			break;
			
		if ( dlg.event == 'numpoints' || dlg.event == 'SelectCurve' || dlg.event == 'Build' )
		{
		Update( UI.numpoints.integerValue, UI.SelectCurve.value, UI.Build.value, factories);
		}
	}
	
	Commit( factories );
}

DoHarmonicKnot();
