// HilbertCurve2D-05Fast v.04 - Brian McMillin January 27, 2014.  Based upon previous, slower, HilbertCurve script.
// A lot of code is adapted from Max Smirnov's _SpherePoints script, which uses faster htm file execution of some functions.
// A potential drawback is that MoI may "hang up" until the function is finished, if it takes too long.
// If the function does not finish, MoI would need to be escaped from and reloaded, and work lost if it has not been previously saved.
// The "heavy" recursion(?), and/or global objList (?), and/or multiple geometryDatabase.creations (?), seems to "exhaust" some kind of resources,
// at level 8, as does multiple switching between curves or levels.
// That is the reason that the Level is set to a maximum of 6.

// Creation of pointList in a recursion is shown, with ObjectList.  In other scripts, a non-global ObjectList may be better?
// Creation of polyline or control point curve is shown, with local ObjectList.

// Level 6 could be replaced with level 7, which takes at least 3 seconds to appear.
// Level 8 would either take a minute, or lock up.
// It takes a similar amount of time for Done or Cancel to happen.
 function LimitLevel(levnum)
	{
	var lev = Math.abs(levnum); //Negative level is not allowed. 
	if ( lev > 6 ) //Set the maximum level.
	lev = 6;
//	lev = 7;
	if ( lev < 1 ) //zero causes faults.
	lev = 1;
	return lev;
	}

function DoHilbertKoch()
{
	var UI = moi.ui.commandUI;
	var dlg = moi.ui.commandDialog;	
	var level = LimitLevel(UI.num.integerValue);
	objList3 = moi.geometryDatabase.createObjectList(); //empty.
	objList = moi.geometryDatabase.createObjectList(); //to clear it out.
	// firstStart is true.
	var pointsList = UI.calcPoints(UI.x0.value, UI.y0.value, UI.xi.value, UI.xj.value, UI.yi.value, UI.yj.value, level, true );
	var curveList = UI.get_polyline_curve(pointsList, UI.Build.value);
	if ( moi.ui.commandUI.ShowPtsCheckbox.value) {moi.geometryDatabase.addObjects(pointsList);}
	moi.geometryDatabase.addObjects(curveList);
	
	while ( true )
	{
		dlg.waitForEvent();
		if ( dlg.event === 'done' ) break;

		if ( dlg.event == 'x0' || dlg.event == 'y0' || dlg.event == 'xi' || dlg.event == 'xj' || dlg.event == 'yi' || dlg.event == 'yj' || dlg.event == 'num' )
		{
			moi.geometryDatabase.removeObjects(pointsList); 
			moi.geometryDatabase.removeObjects(curveList);
			var level = LimitLevel(UI.num.integerValue);
			objList = objList3; //reset to empty.
			pointsList = UI.calcPoints(UI.x0.value, UI.y0.value, UI.xi.value, UI.xj.value, UI.yi.value, UI.yj.value, level, true);
			if ( moi.ui.commandUI.ShowPtsCheckbox.value) {moi.geometryDatabase.addObjects(pointsList);}			
			curveList = UI.get_polyline_curve(pointsList, UI.Build.value);
			moi.geometryDatabase.addObjects(curveList);			
		}
		else if (dlg.event == 'Build')
		{
			moi.geometryDatabase.removeObjects(curveList);
			curveList = UI.get_polyline_curve(pointsList, UI.Build.value);
			moi.geometryDatabase.addObjects(curveList);			
		}
		else if (dlg.event === 'ShowPtsCheckbox' )
		{
			if ( moi.ui.commandUI.ShowPtsCheckbox.value) {moi.geometryDatabase.addObjects(pointsList);}
			else {moi.geometryDatabase.removeObjects(pointsList);}
		}
		else
		{
			moi.geometryDatabase.removeObjects(pointsList);
			moi.geometryDatabase.removeObjects(curveList);
			return;
		}
	}
}
DoHilbertKoch();