// config: norepeat

#include "GetObjects.js"
#include "GetPoint.js"

function MakeCircle( pointpicker )
{
	// Returns object list with circle in it, or null if invalid radius.

	var radius = moi.ui.commandUI.radius.value;
	if ( radius <= 0.0 )
		return null;

	var factory = moi.command.createFactory( 'circle' );
	factory.setInput( 0, true ); // Is radius - true means value is radius, false value include
	factory.setInput( 1, pointpicker.ptframe ); // Coordinate frame for center point and x/y axes.
	factory.setInput( 3, radius );

	return factory.calculate();
}

function BooleanUnion( BaseObjList, CircleObjList )
{
	var objs = moi.geometryDatabase.createObjectList();

	for ( var i = 0; i < BaseObjList.length; ++i )
		objs.addObject( BaseObjList.item(i) );

	for ( var i = 0; i < CircleObjList.length; ++i )
		objs.addObject( CircleObjList.item(i) );

	var factory = moi.command.createFactory( 'booleanunion' );
	factory.setInput( 0, objs );

	var result = factory.calculate();

	if ( result.length == 0 )
		return BaseObjList;

	moi.geometryDatabase.removeObjects( BaseObjList );
	moi.geometryDatabase.addObjects( result );

	return result;
}

function DoInsertCircle()
{
	var objectpicker = moi.ui.createObjectPicker();
	if ( !GetObjects( objectpicker ) )
		return;
		
	var BaseObjList = objectpicker.objects;

	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'SelectPrompt' );
	moi.ui.showUI( 'CenterPointPrompt' );
	moi.ui.showUI( 'RadiusOptions' );
	moi.ui.endUIUpdate();
	
	var pointpicker = moi.ui.createPointPicker();

	while ( 1 )
	{
		if ( !pointpicker.waitForEvent() )
			break;

		if ( pointpicker.event == 'done' )
			break;
			
		if ( pointpicker.event == 'finished' )
		{
			var c = MakeCircle( pointpicker );
			if ( c )
				BaseObjList = BooleanUnion( BaseObjList, c );
		}
	}
}

DoInsertCircle();
