
function alert( msg )
{
	moi.ui.commandUI.alert( msg );
}

function Cancel( factories )
{
	for ( var i = 0; i < factories.length; ++i )
		factories[i].cancel();
		
	factories.length = 0;
}

function Commit( factories )
{
	for ( var i = 0; i < factories.length; ++i )
		factories[i].commit();
}

// theta, an angle parameter, varies fractionally from 0 to 2*PI
function EvalLissajous(t, aV, bV, cV, n1, n2, n3, A1, A2)
{
	var theta;
	theta = Math.PI * 2.0 * t;
	var x = aV * Math.cos(n1 * theta);
	var y = bV * Math.sin(n2 * theta + A1);
	var z = cV * Math.sin(n3 * theta + A2);
	return moi.vectorMath.createPoint( x, y, z );
}

function Update(aV, bV, cV, n1, n2, n3, A1, A2, numpoints, buildtype, factories)
{
	Cancel( factories );

	if ( buildtype == 'points' )
	{
		var pointfactory = moi.command.createFactory( 'point' );
	
		for ( var i = 0; i < numpoints; ++i )
		{
			var t = i / (numpoints - 1 );
			var pt = EvalLissajous(t, aV, bV, cV, n1, n2, n3, A1, A2);
	
			var pointfactory = moi.command.createFactory( 'point' );
			pointfactory.setInput( 0, pt );
			factories.push( pointfactory );
		}
	}	
	
	else
	{
		var factory = moi.command.createFactory( 'curve' );	
	
		for ( var i = 0; i < numpoints; ++i )
		{
			var t = i / (numpoints - 1 );
			var pt = EvalLissajous(t, aV, bV, cV, n1, n2, n3, A1, A2);
			factory.createInput( 'point' );
			factory.setInput( factory.numInputs - 1, pt );
		}
		factories.push( factory );		
	}	
	
	for ( var i = 0; i < factories.length; ++i )
		factories[i].update();
}

function DoLissajous()
{
	var factories = new Array();
	var UI = moi.ui.commandUI;
	Update( UI.aV.numericValue, UI.bV.numericValue, UI.cV.numericValue, UI.n1.numericValue, UI.n2.numericValue, UI.n3.numericValue, UI.A1.numericValue, UI.A2.numericValue, UI.numpoints.integerValue, UI.Build.value, factories);

	// Wait for cancel or done.
	var dlg = moi.ui.commandDialog;

	while ( 1 )
	{
		if ( !dlg.waitForEvent() )
		{
			Cancel( factories );
			return false;
		}
			
		if ( dlg.event == 'done' )
			break;
			
		if ( dlg.event == 'aV' || dlg.event == 'bV' || dlg.event == 'cV' || dlg.event == 'n1' || dlg.event == 'n2' || dlg.event == 'n3' || dlg.event == 'A1' || dlg.event == 'A2' || dlg.event == 'numpoints' || dlg.event == 'Build' )
		{
		Update( UI.aV.numericValue, UI.bV.numericValue, UI.cV.numericValue, UI.n1.numericValue, UI.n2.numericValue, UI.n3.numericValue, UI.A1.numericValue, UI.A2.numericValue, UI.numpoints.integerValue, UI.Build.value, factories);
		}
	}
	
	Commit( factories );
}

DoLissajous();
