// config: norepeat
//	LogSpiral script, by Brian McMillin 9/30/2014
//  Revision of Logarithmic2D script of 9/24/2011. 
//	The Logarithmic Spiral is also known as the EquiAngular spiral, Bernoulli's Spiral, and Spira Mirabilis.
//	The spiral is the Golden Spiral when the exponent is the golden ratio φ / 2PI, about 0.306349.
//	A golden spiral gets wider by a factor of φ for every quarter turn it makes.  (Wikipedia)
//  Click on "Exponent" for a golden spiral. 
//	(Modified from Moi scripts of Michael and Gear script of Max Smirnov) (Formerly called Logarithmic2D)	

#include "GetPoint.js"

function DoLogSpiral()
{
	var pointpicker = moi.ui.createPointPicker();
	if ( !GetPoint( pointpicker ) ) return;
	moi.ui.commandUI.cplane = pointpicker.ptframe;
	var ui = moi.ui.commandUI;

	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'PickPrompt' );
	moi.ui.hideUI( 'CancelContainer' );
	moi.ui.showUI( 'OptionsPrompt' );
	moi.ui.showUI( 'LogSpiralOptions' );
	moi.ui.showUI( 'DoneCancelContainer' );
	moi.ui.endUIUpdate();

	// Show the initial result.
	moi.ui.commandUI.init();
	// Wait for any changes to the UI or cancel or done.
	var dialog = moi.ui.commandDialog;

	while ( 1 )
	{
		if ( !dialog.waitForEvent() )
		{
			if ( moi.ui.commandUI.profile.length !== 0 ) moi.geometryDatabase.removeObjects( moi.ui.commandUI.profile );
			return; // Canceled.
		}
		if ( dialog.event == 'done' ) break; // "Done" pushed.
		moi.ui.commandUI.lastN=-1;
	}
	moi.ui.commandUI.profile.setProperty( 'displayMode',0);
}

DoLogSpiral();
