
function alert( msg )
{
	moi.ui.commandUI.alert( msg );
}

function Cancel( factories )
{
	for ( var i = 0; i < factories.length; ++i )
		factories[i].cancel();
		
	factories.length = 0;
}

function Commit( factories )
{
	for ( var i = 0; i < factories.length; ++i )
		factories[i].commit();
}

function Update(aValue, bValue, cValue, xZero, yZero, zZero, h, numpoints, buildtype, factories)
{
	Cancel( factories );

	var x0 = xZero;
	var y0 = yZero;
	var z0 = zZero;
	var pt = moi.vectorMath.createPoint( x0, y0, z0 );

	if ( buildtype == 'points' )
	{
		var pointfactory = moi.command.createFactory( 'point' );
		pointfactory.setInput( 0, pt );
		factories.push( pointfactory );
	
		for ( var i = 0; i < numpoints; ++i )
		{
			x1 = x0 + h*aValue*(y0 - x0);
			y1 = y0 + h*(x0*(bValue-z0) - y0);
			z1 = z0 + h*(x0 * y0 - cValue * z0);
			x0 = x1;
			y0 = y1;
			z0 = z1;
	
			var pt = moi.vectorMath.createPoint( x0, y0, z0 );
			var pointfactory = moi.command.createFactory( 'point' );
			pointfactory.setInput( 0, pt );
			factories.push( pointfactory );
		}
	}	
	
	else
	{
		var factory = moi.command.createFactory( 'curve' );	
//		var pt = moi.vectorMath.createPoint( x0, y0, z0 );
		factory.createInput( 'point' );
		factory.setInput( factory.numInputs - 1, pt );
	
		for ( var i = 0; i < numpoints; ++i )
		{
			x1 = x0 + h*aValue*(y0 - x0);
			y1 = y0 + h*(x0*(bValue-z0) - y0);
			z1 = z0 + h*(x0 * y0 - cValue * z0);
			x0 = x1;
			y0 = y1;
			z0 = z1;
	
			var pt = moi.vectorMath.createPoint( x0, y0, z0 );		
			factory.createInput( 'point' );
			factory.setInput( factory.numInputs - 1, pt );
		}
		factories.push( factory );		
	}	
	
	for ( var i = 0; i < factories.length; ++i )
		factories[i].update();
}

function DoLorenz()
{
	var factories = new Array();
	var UI = moi.ui.commandUI;
	Update( UI.aValue.numericValue, UI.bValue.numericValue, UI.cValue.numericValue, UI.xZero.numericValue, UI.yZero.numericValue, UI.zZero.numericValue, UI.h.numericValue, UI.numpoints.integerValue, UI.Build.value, factories);

	// Wait for cancel or done.
	var dlg = moi.ui.commandDialog;

	while ( 1 )
	{
		if ( !dlg.waitForEvent() )
		{
			Cancel( factories );
			return false;
		}
			
		if ( dlg.event == 'done' )
			break;
			
		if ( dlg.event == 'aValue' || dlg.event == 'bValue' || dlg.event == 'cValue' || dlg.event == 'xZero' || dlg.event == 'yZero' || dlg.event == 'zZero' || dlg.event == 'h' || dlg.event == 'numpoints' || dlg.event == 'Build' )
		{
		Update( UI.aValue.numericValue, UI.bValue.numericValue, UI.cValue.numericValue, UI.xZero.numericValue, UI.yZero.numericValue, UI.zZero.numericValue, UI.h.numericValue, UI.numpoints.integerValue, UI.Build.value, factories);
		}
	}
	
	Commit( factories );
}

DoLorenz();
