// config: norepeat

#include "WaitForDialogDone.js"

	moi.ui.beginUIUpdate();
	moi.ui.showUI( 'TitleContainer' );
	moi.ui.showUI( 'DiameterContainer' );
	moi.ui.showUI( 'LengthContainer' );
	moi.ui.showUI( 'uLengthContainer' );
	moi.ui.showUI( 'StartContainer');
	moi.ui.endUIUpdate();

	var threadPitch=1.5;
	var alerts = false;

	WaitForDialogDone();
	
	var startTime = new Date();
	
	var threadDiameter = moi.ui.commandUI['diameterinput'].numericValue;
	var threadLength = moi.ui.commandUI['lengthinput'].numericValue;
	var unthreadedLength = moi.ui.commandUI['ulengthinput'].numericValue;
	var offset = 0.01;
	
	moi.ui.beginUIUpdate();
	moi.ui.showUI( 'TitleContainer' );
	moi.ui.hideUI( 'DiameterContainer' );
	moi.ui.hideUI( 'LengthContainer' );
	moi.ui.hideUI( 'uLengthContainer' );
	moi.ui.hideUI( 'StartContainer');
	moi.ui.endUIUpdate();
	
	if (threadDiameter==3) threadPitch=0.5;
	if (threadDiameter==4) threadPitch=0.7;
	if (threadDiameter==5) threadPitch=0.8;
	if (threadDiameter==6) threadPitch=1;
	if (threadDiameter==7) threadPitch=1;
	if (threadDiameter==8) threadPitch=1.25;
	if (threadDiameter==9) threadPitch=1.25;
	if (threadDiameter==10) threadPitch=1.5;	
	if (threadDiameter==11) threadPitch=1.5;
	if (threadDiameter==12) threadPitch=1.75;
	
	//Correct threadLength to allow full turns
	var turns = threadLength / threadPitch;
	if (turns % 1 != 0) threadLength = parseInt(turns + 1) * threadPitch;
	
	
	/*draw thread cutting profile*/
	frame = moi.vectorMath.createFrontFrame();
	frame.origin = moi.vectorMath.createPoint( threadDiameter/2+offset, 0, -1*threadPitch );
	factory = moi.command.createFactory( 'polygonedge' );
	factory.setInput( 0, frame );
	factory.setInput( 1, moi.vectorMath.createPoint( threadDiameter/2+offset, 0, 0 ) );
	factory.setInput( 2, 3 );
	factory.commit();
	
	moi.geometryDatabase.selectAll();
	
	/*Round off one corner*/
	factory = moi.command.createFactory( 'fillet' );
	var vertexflags = moi.createList();
    vertexflags.add( false );
    vertexflags.add( false );
    vertexflags.add( true ); //select the third vertex (corner point)
    factory.setInput( 2, vertexflags );
	factory.setInput( 0, moi.geometryDatabase.getSelectedObjects() );
    factory.setInput( 3, 0.14434 * threadPitch );
    factory.setInput( 4, "circular" );
    factory.commit();
    
    moi.geometryDatabase.selectAll();
	var profile = moi.geometryDatabase.getSelectedObjects();
	moi.geometryDatabase.getSelectedObjects().item(0).name ="profile";
	
	moi.geometryDatabase.selectAll();

	/*draw helix*/
	var frame = moi.vectorMath.createTopFrame();
	frame.origin = moi.vectorMath.createPoint( 0, 0, -1*threadPitch/2 );
	var factory = moi.command.createFactory( 'helix' );
	factory.setInput( 0, frame );
	factory.setInput( 1, moi.vectorMath.createPoint( 0, 0, threadLength+threadPitch/2 ) );
	factory.setInput( 2, moi.vectorMath.createPoint( threadDiameter/2, 0, 0 ) );
	factory.setInput( 6, threadLength+1 );
	factory.setInput( 7, threadPitch );
	factory.setInput( 8, 'flat' );
	factory.commit();
	
	moi.geometryDatabase.invertSelection();
	moi.view.resetAll();
	var rail = moi.geometryDatabase.getSelectedObjects();

	if (alerts) moi.ui.alert( "rail + profile. thread length = " + threadLength );
	
	
	/*sweep profile along rail*/
	moi.geometryDatabase.selectAll();
	var list = moi.createList();
	list.add( moi.vectorMath.createPoint( 0, 0, 0 ) );
	list.add( moi.vectorMath.createPoint( 0, 0, 1 ) );
	factory = moi.command.createFactory( 'sweep' );
	factory.setInput( 0, profile );
	factory.setInput( 1, rail );
	factory.setInput( 2, list );
	/*Ends:*/ factory.setInput( 4, 'Regular' );
	/*Twist:*/ factory.setInput( 5, 'Flat' );
	/*Cap ends:*/ factory.setInput( 7, true );
	/*Profiles:*/ factory.setInput( 10, 'Exact' );
	factory.commit();
	moi.geometryDatabase.invertSelection();
	var cutter = moi.geometryDatabase.getSelectedObjects();
	
	if (alerts) moi.ui.alert( "cutter" );
	
	/*delete rail*/
	factory = moi.command.createFactory( 'delete' );
	factory.setInput( 0, rail );
	factory.commit();
	
	/*lock profile*/	
	moi.geometryDatabase.deselectAll();
	moi.geometryDatabase.selectNamed("profile");
	moi.geometryDatabase.lock();
	
	/*draw cylinder*/
	moi.geometryDatabase.selectAll();
	frame = moi.vectorMath.createTopFrame();
	frame.origin = moi.vectorMath.createPoint( 0, 0, 0 );
	factory = moi.command.createFactory( 'cylinder' );
	factory.setInput( 1, frame );
	factory.setInput( 3, threadDiameter/2 );
	factory.setInput( 4, moi.vectorMath.createPoint( 0, 0, threadLength + unthreadedLength ) );
	factory.commit();
	moi.geometryDatabase.invertSelection();
	var cylinder = moi.geometryDatabase.getSelectedObjects();
	moi.geometryDatabase.getSelectedObjects().item(0).name ="cylinder";

	
	if (unthreadedLength==0) {
		factory = moi.command.createFactory( 'chamfer' );
		factory.setInput( 0, moi.geometryDatabase.getSelectedObjects() );
		factory.setInput( 3, threadPitch );
		factory.setInput( 4, threadPitch );
		factory.commit();
	} else {
		// Build a new object list with the first edge in it.
		var chamferList = moi.geometryDatabase.createObjectList();
		chamferList.addObject( moi.geometryDatabase.getSelectedObjects().item(0).getEdges().item(0) );
		factory = moi.command.createFactory( 'chamfer' );
		factory.setInput( 0, chamferList );
		factory.setInput( 3, threadPitch );
		factory.setInput( 4, threadPitch );
		factory.commit();
	}
	
	moi.geometryDatabase.deselectAll();
	moi.geometryDatabase.selectNamed("cylinder");
	cylinder = moi.geometryDatabase.getSelectedObjects();
	moi.view.resetAll();
	
	if (alerts) moi.ui.alert( "cylinder" );
	
	/*Boolean difference*/
	moi.geometryDatabase.deselectAll();
	factory = moi.command.createFactory( 'booleandifference' );
	factory.setInput( 0, cylinder );
	factory.setInput( 1, cutter );
	factory.setInput( 2, false );
	factory.commit();
	
	moi.geometryDatabase.selectAll();
	var rod = moi.geometryDatabase.getSelectedObjects();
	moi.geometryDatabase.getSelectedObjects().item(0).name ="rod";
	

	if (unthreadedLength > 0) {
	
		/*draw tapered helix*/
		moi.geometryDatabase.selectAll();
		frame.origin = moi.vectorMath.createPoint( 0, 0, threadLength + threadPitch/2);
		factory = moi.command.createFactory( 'helix' );
		factory.setInput( 0, frame );
		factory.setInput( 1, moi.vectorMath.createPoint( 0, 0, threadLength+ threadPitch/2+threadPitch ) );
		factory.setInput( 2, moi.vectorMath.createPoint( threadDiameter/2, 0, 0 ) );
		factory.setInput( 4, moi.vectorMath.createPoint( threadDiameter/2 + 0.86603*threadPitch, 0, 0 ) );
		factory.setInput( 6, 1 );
		factory.setInput( 7, threadPitch );
		factory.setInput( 8, 'flat' );
		factory.commit();
		moi.geometryDatabase.invertSelection();
		rail = moi.geometryDatabase.getSelectedObjects();
		moi.geometryDatabase.getSelectedObjects().item(0).name ="rail";
		
		//unlock profile
		moi.geometryDatabase.deselectAll();
		moi.geometryDatabase.lock();
		
		//move profile to end of previous thread
		moi.geometryDatabase.selectNamed("profile");
		var objectlist = moi.geometryDatabase.getSelectedObjects();
		var bbox = objectlist.getHighAccuracyBoundingBox();
		var pt = bbox.center;
		pt.z += threadLength + threadPitch;
		factory = moi.command.createFactory( "move" );
		factory.setInput( 0, moi.geometryDatabase.getSelectedObjects() );
		factory.setInput( 1, bbox.center );
		factory.setInput( 2, pt );
		factory.commit();
		moi.geometryDatabase.selectNamed("profile");
		profile = moi.geometryDatabase.getSelectedObjects();

		/*sweep profile along rail*/
		moi.geometryDatabase.selectAll();
		list = moi.createList();
		list.add( moi.vectorMath.createPoint( 0, 0, 0 ) );
		list.add( moi.vectorMath.createPoint( 0, 0, 1 ) );
		factory = moi.command.createFactory( 'sweep' );
		factory.setInput( 0, profile );
		factory.setInput( 1, rail );
		factory.setInput( 2, list );
		/*Ends:*/ factory.setInput( 4, 'Regular' );
		/*Twist:*/ factory.setInput( 5, 'Flat' );
		/*Cap ends:*/ factory.setInput( 7, true );
		/*Profiles:*/ factory.setInput( 10, 'Exact' );
		factory.commit();
		moi.geometryDatabase.invertSelection();
		cutter = moi.geometryDatabase.getSelectedObjects();
		
		moi.geometryDatabase.deselectAll();
		factory = moi.command.createFactory( 'booleandifference' );
		factory.setInput( 0, rod );
		factory.setInput( 1, cutter );
		factory.setInput( 2, false );
		factory.commit();
		
		factory = moi.command.createFactory( 'delete' );
		factory.setInput( 0, rail );
		factory.commit();
		
		factory = moi.command.createFactory( 'delete' );
		factory.setInput( 0, profile );
		factory.commit();

	}
			
	moi.geometryDatabase.selectAll();
	moi.view.resetAll();
	
	var timeDiff = new Date() - startTime; // time difference in ms
	timeDiff /= 1000; // strip the miliseconds
	var seconds = Math.round(timeDiff % 60); // get seconds
	//moi.ui.alert( "Making this took: " + seconds + " s" );	
	