// config: norepeat

#include "GetObjects.js"

function Update( Factories, NumItems )
{
	for ( var i = 0; i < Factories.length; ++i )
	{
		//get points to interpolate
		Factories[i][0].setInput( 3, NumItems );
		var points = Factories[i][0].calculate();

//		Factories[i][1].reset();

		while ( Factories[i][1].numInputs > 1 )
			Factories[i][1].removeLastInput();

		for ( var j = 0; j < points.length; ++j )
		{
			Factories[i][1].createInput( 'point' );
			Factories[i][1].setInput( Factories[i][1].numInputs - 1, points.item(j).pt );
		}

		if ( Factories[i][2] )	// closed curve
		{
			Factories[i][1].createInput( 'point' );
			Factories[i][1].setInput( Factories[i][1].numInputs - 1, Factories[i][1].getInput(0).getValue() );
		}

		Factories[i][0].update();
		Factories[i][1].update();
	}
}

function ReconstructCurve()
{
	var ObjectPicker = moi.ui.createObjectPicker();
	ObjectPicker.allowStandaloneCurves();

	if ( !GetObjects( ObjectPicker ) )
		return;

	var Curves = ObjectPicker.objects;

	Curves.setProperty( 'locked', true );

	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'SelectPrompt' );
	moi.ui.hideUI( 'ReconstructOptions' );
	moi.ui.showUI( 'ReconstructPrompt' );
	moi.ui.showUI( 'ReconstructPtOptions' );
	moi.ui.endUIUpdate();

	var pointfactory = moi.command.createFactory( 'point' );

	var fact = moi.ui.commandUI.reconstructas.value;
	var Factories = new Array( Curves.length );

	for ( var i = 0; i < Curves.length; ++i )
	{
		var originalCrv = Curves.item(i);
		var startPt = originalCrv.getStartPt();

		// create point object to array
		pointfactory.setInput( 0, startPt );
		var startPtObject = pointfactory.calculate();

		Factories[i] = new Array(3);

		var Factory = moi.command.createFactory( 'arraycurve' );
		Factory.setInput( 0, startPtObject );		// object (list)
		Factory.setInput( 1, originalCrv );		// path
		Factory.setInput( 2, 'NumItems' );		// array mode
		Factories[i][0] = Factory;

		Factory = moi.command.createFactory( fact );
		Factory.createInput( 'point' );
		Factory.setInput( 0, startPt );
		Factories[i][1] = Factory;

		Factories[i][2] = originalCrv.isClosed;
	}

	pointfactory.cancel();

	// Get the values from the UI controls.
	var NumItems = moi.ui.commandUI.NumItems.integerValue;

	// Show the initial result.
	Update( Factories, NumItems );

	// Wait for cancel or done.
	var dialog = moi.ui.commandDialog;

	while ( 1 )
	{
		if ( !dialog.waitForEvent() )
		{
			Curves.setProperty( 'locked', false );
			return; // Canceled.
		}

		if ( dialog.event == 'done' )
			break;

		if ( dialog.event == 'NumItems' )
		{
			// NumItems control changed
			NumItems = moi.ui.commandUI.NumItems.integerValue;
			Update( Factories, NumItems );
		}
	}

	Curves.setProperty( 'locked', false );

	if ( moi.ui.commandUI.deletecurves.value )
		moi.geometryDatabase.removeObjects( Curves );

	// All done, commit the factories.
	for ( var i = 0; i < Factories.length; ++i )
		Factories[i][1].commit();
//		Factories[i][0].cancel();
}

ReconstructCurve();
