
function alert( msg )
{
	moi.ui.commandUI.alert( msg );
}

function EvalSincFunction( t, amplitude, length, numcycles, norm )
{
	var z = 0.0;
	if (t == 0)
	{
		var y = 1.0 * amplitude;
	}
	else
	{
		var y = Math.sin( t * norm * Math.PI * 2.0 * numcycles ) * amplitude / (t * norm * Math.PI * 2 * numcycles);
	}
	var x = t * length * numcycles;

//		var y = Math.sin( t * Math.PI * 2.0 * numcycles ) * amplitude / (t * Math.PI * 2.0 * numcycles);
//	}
//	var x = t * length * numcycles;


	
	return moi.vectorMath.createPoint( x, y, z );
}

function Update()
{
	var factory = moi.command.createFactory( 'curve' );

	var amplitude = moi.ui.commandUI.amplitude.numericValue;
	var length = moi.ui.commandUI.len.numericValue;
	var numcycles = moi.ui.commandUI.numcycles.integerValue;
	var numpoints = moi.ui.commandUI.numpoints.integerValue * numcycles;
	if ( moi.ui.commandUI.normalize.value )
	{
		var norm = Math.PI;
	}
	else
	{
		var norm = 1.0;
	}
	
	for ( var i = 0; i < numpoints; ++i )
	{
		var t = i / (numpoints - 1);
		
		var pt = EvalSincFunction( t, amplitude, length, numcycles, norm );		
		
		factory.createInput( 'point' );
		factory.setInput( factory.numInputs - 1, pt );
	}
	
	factory.update();
	
	return factory;
}

function DoSinc()
{
	var factory = Update();

	var dlg = moi.ui.commandDialog;
	
	while ( 1 )
	{
		if ( !dlg.waitForEvent() )
		{
			factory.cancel();
			return false;
		}
			
		if ( dlg.event == 'done' )
			break;
			
		if ( dlg.event == 'amplitude' || dlg.event == 'len' || dlg.event == 'numcycles' || dlg.event == 'numpoints' || dlg.event == 'normalize' )
		{
			factory.cancel();
			factory = Update();
		}
	}
	
	factory.commit();
}

DoSinc();
