//	SuperFormula2D MoI script (2D version) 
//	Based upon equations by Johan Gielis http://www.amjbot.org/content/90/3/333.short
//	"A GENERIC GEOMETRIC TRANSFORMATION THAT UNIFIES A WIDE RANGE OF NATURAL AND ABSTRACT SHAPES"
//	Supershapes by Paul Borke http://paulbourke.net/geometry/supershape/
//	DRAFT by Brian McMillin December 5, 2011
//	There are several programs on the net, even a version for the iphone.	

function alert( msg )
{
	moi.ui.commandUI.alert( msg );
}

function Update()
{
	var factory = moi.command.createFactory( 'interpcurve' );
//	var factory = moi.command.createFactory( 'curve' );

	var aValue = moi.ui.commandUI.aValue.numericValue;
	var bValue = moi.ui.commandUI.bValue.numericValue;
	var mValue = moi.ui.commandUI.mValue.numericValue;
	var n1Value = moi.ui.commandUI.n1Value.numericValue;
	var n2Value = moi.ui.commandUI.n2Value.numericValue;	
	var n3Value = moi.ui.commandUI.n3Value.numericValue;	
	var phi_multiple = moi.ui.commandUI.phi_multiple.numericValue;
	var numpoints = moi.ui.commandUI.numpoints.integerValue;	
	var trig1
	var trig2
	var phi
	var radius1
	
	for ( var i = 0; i <= numpoints; ++i )
	{
		var t = i / (numpoints);
		phi = Math.PI * 2.0 * t * phi_multiple;
	
		trig1 = (Math.cos( mValue * phi / 4.0)) / aValue;
		trig1 = Math.abs(trig1);
		trig1 = Math.pow(trig1,n2Value);
		
		trig2 = (Math.sin( mValue * phi / 4.0)) / bValue;		
		trig2 = Math.abs(trig2);
		trig2 = Math.pow(trig2,n3Value);		

		radius1 = Math.pow(trig1+trig2 , 1.0 / n1Value)
		
	// Define x, y and z values.
		z = 0.0;
		if ( Math.abs(radius1) == 0.0 )
		{
			x = 0.0;
			y = 0.0;
		}
		else
		{
			radius1 = 1.0 / radius1;
			var x = radius1 * Math.cos(phi);
			var y = radius1 * Math.sin(phi);
		}
		
		var pt = moi.vectorMath.createPoint( x, y, z );	

		factory.createInput( 'point' );
		factory.setInput( factory.numInputs - 1, pt );
	}

//	Note, the next alert line was used in debugging.
//	alert("to here3")

	factory.update();	

//alert("to here4")	
	return factory;
}

function Supershapes()
{
	var factory = Update();

	var dlg = moi.ui.commandDialog;
	
	while ( 1 )
	{
		if ( !dlg.waitForEvent() )
		{
			factory.cancel();
			return false;
		}
			
		if ( dlg.event == 'done' )
			break;
			
		if ( dlg.event == 'aValue' || dlg.event == 'bValue' || dlg.event == 'mValue' || dlg.event == 'n1Value' || dlg.event == 'n2Value' || dlg.event == 'n3Value' || dlg.event == 'curve_slider' || dlg.event == 'phi_multiple' ||  dlg.event == 'numpoints' )
		{
			factory.cancel();
			factory = Update();
		}
	}
	
	factory.commit();
}

Supershapes();