//	Circular SineWave script, 2/23/2012.
//	Foremerly WaveSpring script of 11/21/2012
//	by Brian E. McMillin

function alert( msg )
{
	moi.ui.commandUI.alert( msg );
}

function EvalCircularSineWave( t, radius, numwaves, amplitude, flat )
{
  // theta is the rotational angle parameter, (0 to 2pi) , to generate 360 degree profile.
  var theta;
  theta = Math.PI * 2.0 * t;
  // radius = radius of circle.
  // numwaves = number of sine waves.

  // flat == true, is for a 2d circular sine wave, .
  // flat == false, is for sine wave amplitude along the z axis.
  // Define x, y and z values.  
  
  if (flat)
  {

	var x = (radius + amplitude * Math.sin( numwaves * theta )) * Math.cos(theta);
	var y = (radius + amplitude * Math.sin( numwaves * theta )) * Math.sin(theta)
	var z = 0;	
  }		

  else
  {
	// Define x, y and z values.
	var x = radius * Math.cos( theta );
	var y = radius * Math.sin( theta );
	var z = amplitude * Math.sin(numwaves * theta );	
  }		
	return moi.vectorMath.createPoint( x, y, z );
	
}

function Update()
{
	var factory = moi.command.createFactory( 'curve' );
 	var radius = moi.ui.commandUI.radius.numericValue;
	var numwaves = moi.ui.commandUI.numwaves.integerValue;
	var amplitude = moi.ui.commandUI.amplitude.numericValue;
	var numpoints = moi.ui.commandUI.numpoints.integerValue * numwaves;
	var flat = moi.ui.commandUI.flat.value;
	
	for ( var i = 0; i < numpoints; ++i )

	{
		var t = i / (numpoints - 1);
		
		var pt = EvalCircularSineWave( t, radius, numwaves, amplitude, flat )		
		
		factory.createInput( 'point' );
		factory.setInput( factory.numInputs - 1, pt );
	}
	
	factory.update();
	
	return factory;
}

function DoCircularSineWave()
{
	var factory = Update();

	var dlg = moi.ui.commandDialog;
	
	while ( 1 )
	{
		if ( !dlg.waitForEvent() )
		{
			factory.cancel();
			return false;
		}
			
		if ( dlg.event == 'done' )
			break;
			
		if ( dlg.event == 'radius' || dlg.event == 'numwaves' || dlg.event == 'amplitude' || dlg.event == 'numpoints' || dlg.event == 'flat' )
		{
			factory.cancel();
			factory = Update();
		}
	}
	
	factory.commit();
}

DoCircularSineWave();
